/*
   *
   * bclient.c - Bytes Counter simple Client
   *
   * Copyright (c) 2002 Aleksander Augustowski
   *
   * BUG RAPORTS &
   * E-MAIL:          aleksander.augustowski@ins.com.pl
   * URL:             http://www.ins.com.pl/~alex/bcount/bcount.html
   *
   * This software is open source; you can redistribute it and/or modify
   * it under the terms of the GNU General Public License as published by
   * the Free Software Foundation; either version 2 of the License.
   *
   * This program is distributed WITHOUT ANY WARRANTY; without even the
   * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
   * See the GNU General Public License in the included COPYING file for
   * details.
   *
   *
*/

#include "bclient.h"


int main(int argc, char** argv)
{

 int csd, n, t = 0, g = 0;
 char buf[1024];
 char send_version[] = { CVERSION };
 char server_interface[10];
 char server_version[10];
 char temp[20];
/* int server_int_data_rx, server_int_data_tx; */
 float server_float_data_rx, server_float_data_tx;
 float server_float_Kdata_rx, server_float_Kdata_tx;
 float server_float_Mdata_rx, server_float_Mdata_tx;
 struct sockaddr_in adres;
 struct servent *serv;
 struct hostent *host;
 
 if (argc < 2)
    {
        printf ("Usage: %s host\n\
Example: deth.org.pl or\n\
\t 212.244.8.34\n", argv[0]);
        return(1);
    }

  
 bzero ((char *) &adres, sizeof(adres));
 adres.sin_family = AF_INET;
 
 host = gethostbyname (argv[1]);
 if (host != NULL)
    bcopy (host->h_addr, (char *) &adres.sin_addr, host->h_length);
    else
       {
	  fprintf(stderr, "%s\n", strerror(errno));
	  exit(1);
       }
       
 serv = getservbyport (htons(SPORT), "tcp");
 if (serv != NULL)
    adres.sin_port = serv->s_port;
    else
       {
         perror ("getservbyport()");
	 printf ("Please add \"bcount\t%d/tcp\" in /etc/services\n\
\tor \"doom\t%d/tcp\" in /etc/services\n", SPORT, SPORT);
         return(1);
       }
 
 csd = socket (PF_INET, SOCK_STREAM, 0);
 if (csd == -1)
   {
      fprintf(stderr, "%s: socket()\n", strerror(errno));
      exit(1);
   }

 if (connect (csd, (struct sockaddr *) &adres, sizeof(adres)) < 0)
    {
       fprintf(stderr, "%s: connect()\n", strerror(errno));
       close(csd);
       exit(1);
    }

    
    /* Send self version number to server */
    n = write (csd, send_version, sizeof(send_version));
    if (n < 0)
	{
	    fprintf(stderr, "%s: write\n", strerror(errno));
	    exit(1);
	}

    if (shutdown (csd, SHUT_WR) == -1)
	{
	    fprintf(stderr, "%s: shutdown (SHUT_WR)\n", strerror(errno));
	    exit(1);
	}
    
    /* Get data from server */
    n = read (csd, buf, sizeof(buf));
    if (n < 0)
	{
	    fprintf(stderr, "%s: read\n", strerror(errno));
	    exit(1);
	}
    
    /* add NULL byte*/
    buf[n] = 0;
    

    close(csd);
    

    /* Writing data to variables */	   
	   while (buf[t] != '\n')
		{
		   server_interface[g] = buf[t];
		   t++;
		   g++;
		}

	   server_interface[g] = '\0';
	   g = 0;
	   t++;
	    
	   while (buf[t] != '\n')
		{
		   temp[g] = buf[t];
		   t++;
		   g++;
		}
		
	   temp[g] = '\0';
	   /* server_int_data_rx = atoi(temp); */
	   server_float_data_rx = atof(temp);
	   server_float_Kdata_rx = server_float_data_rx / 1024;
	   g = 0;
	   t++;

	   while (buf[t] != '\n')
		{
		   temp[g] = buf[t];
		   t++;
		   g++;
		}
		
	   temp[g] = '\0';
	   /* server_int_data_tx = atoi(temp); */
	   server_float_data_tx = atof(temp);
	   server_float_Kdata_tx = server_float_data_tx / 1024;
	   g = 0;
	   t++;

	   while (buf[t] != '\n')
		{
		   server_version[g] = buf[t];
		   t++;
		   g++;
		}

	   server_version[g] = '\0';

	   
  printf ("Bytes Counter client version %s\n\n", CVERSION);
  printf (" Interface - %s\t\t[ Interface examine ]\n", server_interface);

  if (server_float_Kdata_tx > 1024)
     printf ("Transmited - %.1f MB\t\t[ Data transmited ]\n", server_float_Mdata_tx = server_float_Kdata_tx / 1024);
     else
        printf ("Transmited - %.1f KB\t\t[ Data transmited ]\n", server_float_Kdata_tx);

  if (server_float_Kdata_rx > 1024)
     printf ("  Received - %.1f MB\t\t[ Data received ]\n", server_float_Mdata_rx = server_float_Kdata_rx / 1024);
     else
        printf ("  Received - %.1f KB\t\t[ Data received ]\n", server_float_Kdata_rx);

  printf ("  Saddress - %s\t[ Server IP ]\n", inet_ntoa(adres.sin_addr));

  printf ("  Sversion - %s\t\t[ Server version ]\n\n", server_version);
  printf ("Server works on port: %d\n", SPORT);


 return(0);

}

