//----------------------------------------------------------------------------
/*
   * bclient.c - Bytes Counter simple Client
   *             for Window$
   *
   * Copyright (c) 2002 Aleksander Augustowski
   *
   * BUG RAPORTS &
   * E-MAIL:          aleksander.augustowski@ins.com.pl
   * URL:             http://www.ins.com.pl/~alex/bcount/bcount.html
   *
   * This software is open source; you can redistribute it and/or modify
   * it under the terms of the GNU General Public License as published by
   * the Free Software Foundation; either version 2 of the License.
   *
   * This program is distributed WITHOUT ANY WARRANTY; without even the
   * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
   * See the GNU General Public License in the included COPYING file for
   * details.
*/
//----------------------------------------------------------------------------
//---------------------------------------------------------------------------
#include <vcl.h>
//#pragma hdrstop

#include "main.h"
//---------------------------------------------------------------------------
//#pragma link "ScktComp"

#pragma resource "*.dfm"
#define CWVERSION "0.1win"

char version_cl[]= { CWVERSION };

TBwclient *Bwclient;
//---------------------------------------------------------------------------
__fastcall TBwclient::TBwclient(TComponent* Owner)
        : TForm(Owner)
{
    Application->Title = "Bytes Counter Client";
    Application->Icon->LoadFromFile("internet.ico");

}
//---------------------------------------------------------------------------

void __fastcall TBwclient::FileListenItemClick(TObject *Sender)
{
     ClientSocket->Active = false;
     StatusBar1->Panels->Items[0]->Text = "";
        
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TBwclient::FileConnectItemClick(TObject *Sender)
{
  if (ClientSocket->Active)
  { 
    ClientSocket->Active = false;
  }   
  if (InputQuery("Connect to Bytes Counter Server", "Address Name:", Server))
  {
     if (Server.Length() > 0)
     {
        ClientSocket->Host = Server;
        ClientSocket->Active = true;
     }
  }
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TBwclient::Exit1Click(TObject *Sender)
{
  ClientSocket->Close();
  Close();   
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TBwclient::FormCreate(TObject *Sender)
{
  FileListenItemClick(NULL);   
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TBwclient::ClientSocketConnect(TObject *Sender,
      TCustomWinSocket *Socket)
{
  StatusBar1->Panels->Items[0]->Text = "Connected to: "+Socket->RemoteHost;
  
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TBwclient::Disconnect1Click(TObject *Sender)
{
    ClientSocket->Active = false;
    StatusBar1->Panels->Items[0]->Text = "Disconnected";
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TBwclient::ClientSocketDisconnect(TObject *Sender,
      TCustomWinSocket *Socket)
{
  FileListenItemClick(NULL);   
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TBwclient::ClientSocketError(TObject *Sender,
      TCustomWinSocket *Socket, TErrorEvent ErrorEvent, int &ErrorCode)
{
  StatusBar1->Panels->Items[0]->Text = "Error connecting to: " + Server;
  ErrorCode = 0;
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TBwclient::ClientSocketConnecting(TObject *Sender,
        TCustomWinSocket *Socket)
{
  StatusBar1->Panels->Items[0]->Text = "Connecting...";
}
//---------------------------------------------------------------------------

void __fastcall TBwclient::ClientSocketLookup(TObject *Sender,
      TCustomWinSocket *Socket)
{
  StatusBar1->Panels->Items[0]->Text = "Lookup host: " + Server;
}
//---------------------------------------------------------------------------


void __fastcall TBwclient::About1Click(TObject *Sender)
{
  MessageBox(NULL, "Byte Counter Client for Window$ \n"
                        "Version 0.1win\n"
                        "(c) 2002 Aleksander Augustowski \n\n"
                        "NOTE: This program works only while \n"
                        "Bytes Counter server is running!\n\n"
                        "THIS IS PRE-ALPHA RELEASE !\n"
                        "          !TEST PROGRAM !",
                        "About", MB_OK | MB_ICONINFORMATION);
}
//---------------------------------------------------------------------------

void __fastcall TBwclient::ClientSocketWrite(TObject *Sender,
      TCustomWinSocket *Socket)
{
  Socket->SendText(version_cl);
}
//---------------------------------------------------------------------------

void __fastcall TBwclient::Label2Click(TObject *Sender)
{
   ShellExecute(GetDesktopWindow(), "open",
   "http://www.ins.com.pl/~alex/bcount/bcount.html", NULL, NULL,
                SW_SHOWNORMAL);
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

void __fastcall TBwclient::Label1Click(TObject *Sender)
{

  AnsiString path("mailto:aleksander.augustowski@ins.com.pl?subject=Bytes Counter");
  HINSTANCE r = ShellExecute(Handle,"open",path.c_str(), 
  NULL,NULL,SW_SHOWDEFAULT);
  if (int(r) <= 32) MessageBox(Handle,
    "Error while open default"
    "e-mail client","""",MB_OK);
}
//---------------------------------------------------------------------------

void __fastcall TBwclient::ClientSocketRead(TObject *Sender,
      TCustomWinSocket *Socket)
{
  Memo1->Lines->Add(Socket->ReceiveText());
}
//---------------------------------------------------------------------------

