/*
   *
   * common.h
   *
   * Copyright (c) 2002 Aleksander Augustowski
   *
   * BUG RAPORTS &
   * E-MAIL:          aleksander.augustowski@ins.com.pl
   * URL:             http://www.ins.com.pl/~alex/bcount/bcount.html
   *
   * This software is open source; you can redistribute it and/or modify
   * it under the terms of the GNU General Public License as published by
   * the Free Software Foundation; either version 2 of the License, or
   * (at your option) any later version.
   *
   * This program is distributed WITHOUT ANY WARRANTY; without even the
   * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
   * See the GNU General Public License in the included COPYING file for
   * details.
   *
   *
*/

#include <sys/types.h>
#include <sys/socket.h>
#include <linux/if_packet.h>
#include <linux/if.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <unistd.h>
#include <signal.h>
#include <ctype.h>
#include <string.h>
#include <syslog.h>


/* Data received over network interface (RX) */
#define RX_BYTES	1
#define RX_PACKETS	2
#define RX_ERRS		3
#define RX_DROP		4
#define RX_FIFO		5
#define RX_FRAME	6
#define RX_COMPRESSED	7
#define RX_MULTICAST	8

/* Data transmited over network interface (TX) */
#define TX_BYTES	9
#define TX_PACKETS	10
#define TX_ERRS		11
#define TX_DROP		12
#define TX_FIFO		13
#define TX_FRAME	14
#define TX_COMPRESSED	15
#define TX_MULTICAST	16
#define CHECK_DEVICE	666			/* Magic Integer ;-) */

#define DEV_FILE	"/proc/net/dev"


static char default_device[16] = "eth0";	/* Define default interface */
static char *device = default_device;
char data_to_send_rx[100], data_to_send_tx[100];
int server_socket, client_socket;
unsigned int int_digit_info;
float float_digit_bytes, float_digit_Kbytes, float_digit_Mbytes;


void device_error(void)
{
   printf ("Device: \033[1;37m%s\033[0m not found, exiting...\n", device);
   exit(1);
}


/* Ignore stop signal (Ctrl+Z) */
static void sigvoid()
{
  signal(SIGTSTP, SIG_IGN);
}

